;### uK4 - 全スクリプト共通(perl 5.8以降対応)
use Encode qw/encode decode from_to/;
use Encode::Guess qw/shift-jis 7bit-jis euc-jp/;	# big5-eten,euc-kr,euc-cn,greek,latin1,...
use Encode::JP::H2Z;				# 半角カタカナ=>全角変換で使用
use File::Path;
use utf8;
;###
$author = 'cop@hunet.jp';			# 作者/連絡先
$k4name = 'uK4';					# UTF対応K4ニモニック
$k4ver  = '0.94f';					# K4 バージョン
$k4perl = '5.8-';					# 対応するperlバージョン
$xcver  = '2.41b';					# 対応するXMailCFGバージョン
$xmver  = '1.24-1.27';				# 対応するXMailバージョン
;###
$bgcolor0 = " bgcolor='#ffd8d8'";	# タイトル部背景色
$bgcolor1 = " bgcolor='#f0fff0'";	# データ部背景色1
$bgcolor2 = " bgcolor='#c8ffc8'";	# データ部背景色2
$bgcolor3 = " bgcolor='#e0ffe0'";	# データ部背景色3
$bgcolor4 = " bgcolor='#e0e0e0'";	# メニュー境界色
$charset  = 'UTF-8';				# UTF文字セット
$charsetE = 'EUC-JP';				# EUC-JP文字セット
$charsetS = 'Shift_JIS';			# Shift_JIS文字セット
$charsetM = 'ISO-2022-JP';			# JIS文字セット
$colorB = "color='#0000ff'";		# 青指定
$colorG = "color='#006000'";		# 緑指定
$colorR = "color='#ff0000'";		# 赤指定
$commonfilter = 'XMailCFG_common_in.tab';	# XMailCFG標準フィルタ定義ファイル
$domainadmintab = 'domainadmin.tab';# ドメイン管理者定義ファイル
$bnreg = "[(\\[{\\/?*.\\-+)\\]}|\\\\]";
$emreg = "\"?[\\w.'#\\-=+]+\"?\@\\[*[\\w.\\-]+\\]*";
$emreg1 = "\"?[\\w!.?*\\/(){|}'#\$%&\\-=+]+\"?\@\\[*[\\w.?*\\-]+\\]*";
$ewreg = "(=\\?)([^?]+)\\?B\\?([^?=]*=*)(\\?=)*";
$ermsg1 = 'システムエラーです！';	# エラーMSG1
$framesize0= 120;					# メニューフレームピクセル数
$k4cookiestr1 = 'uk4ckey1u';		# Cookieキー名
$groupadmintab = 'groupadmin.tab';	# グループ管理定義ファイル
$linespace = '1.5';					# メッセージ表示行間
$listadmintab = 'listadmin.tab';	# リスト管理定義ファイル
$mailbox = 'mailbox';				# メールボックスフォルダ名
$maxchars = 256;					# 入力文字数(メールアドレス長など)制限
$maxmbsize = 10000;					# $MaxMBSize不明時のデフォルト
$spacemin = 100;					# 警告を発するメールボックス残容量しきい値(KB)
$ttitle = 'Welcome!';				# HTMLタイトル
$ttlday = 7;						# 未読MSG有効期間(日)
$ttlmidx = 300;						# MSGインデックス有効時間(秒)
$xmailcfg = 'XMailCFG';				# 環境ファイル存在フォルダ名
$zstr = '\x20-\x7E';				# ASCII文字正規表現
($idir,$tempdir) = ('../image','../temp');	# 画像ディレクトリ、テンポラリディレクトリ
($winx,$winy) = (720,480);			# HTML MSG閲覧ウインドウサイズ
($ctrlclnt,$avscan,$nf) = ('CtrlClnt','.avscan','.nf');		# .nfはフィルタ停止フラグ;
($inbox,$outbox,$draftbox,$spambox,$templatebox,$trashbox) = ($mailbox,'out','draft','spam','template','trash');	# メールボックス
%box = ($inbox,'受信トレイ',$outbox,'送信トレイ',$draftbox,'下書き',$spambox,'迷惑メール',$templatebox,'ひな形',$trashbox,'ごみ箱');
$hr = "<hr color='#D0D0D0' size=1>";
($fe,$fs2,$fs5,$fs5G,$fs5R,$fs7,$fs7G,$fs7R) = ("</font>","<font $colorR>","<font class='doc15'>","<font class='doc15' $colorG>","<font class='doc15' $colorR>","<font class='doc17'>","<font class='doc17' $colorG>","<font class='doc17' $colorR>");
$alert = "<img src='$idir/caution.gif' width=17 height=14 title='!!' border=0>";
$arrowL = "<img src='$idir/arrow_red_t1.gif' width=7 height=9 border=0>";
$arrowR = "<img src='$idir/arrow_red_t.gif' width=7 height=9 border=0>";
$arrowU = "<a href='#top'>上へ<img src='$idir/arrow_u.gif' width=9 height=9 border=0></a>";
$buttonP = "<img src='$idir/button_pink.gif' width=13 height=13 border=0>";
$buttonG = "<img src='$idir/button_green.gif' width=10 height=10 border=0>";
$bodyp = "bgcolor='#ffffff' link='#0000ff' vlink='#0000ff'";
$charcss = "<meta http-equiv='content-type' content='text/html; charset=$charset'><style type='text/css'><!-- a:link{text-decoration:none;}a:visited{text-decoration:none;}a:hover{text-decoration:underline;color:red;}body{font-family:Meiryo,verdana;}button,select{font-family:Meiryo,verdana;}input,textarea{font-family:verdana;}.doc17{font-size:17px;line-height:19px;}.doc15{font-size:15px;line-height:17px;}.doc13{font-size:13px;line-height:16px;}.doc131{font-size:13px;line-height:14px;}.doc12{font-size:12px;line-height:15px;}.doc121{font-size:12px;line-height:13px;}.doc111{font-size:11px;line-height:12px;}--></style><script type='text/javascript'><!--\nfunction opn_win(URL,W,H){var win; win=window.open(URL,'NewWin','toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=1,copyhistory=0,width='+W+',height='+H);}function SetChecked(val){dml=document.mList;len=dml.elements.length;var i=0;for(i=0;i<len;i++){if(dml.elements[i].name=='Mid'){dml.elements[i].checked=val;}}}//--></script>";
$cbody0 = "onMouseOver=\"window.status='';return true\"";
$cbody = "<html><head><title>$ttitle</title>$charcss</head><body $bodyp class='doc131' topmargin=20 leftmargin=20 marginheight=20 marginwidth=20 $cbody0>";
$k4envstr = ',crypt,cgi,ctrlclnt,domain1,extstr,k4envstr,logfile,loginid,mailroot,url,user1,xmailcfgdir,xmaildir,';
$nocache = "<meta http-equiv='Pragma' content='no-cache'><meta http-equiv='Cache-control' content='no-cache'><meta http-equiv='expires' content='-1'>";
$confirm1 = " onClick=\"if(!confirm('本当に削除しますか？')){return false;}\"";
$forward = "<script>history.forward();</script>";
$nofilter = "$fs2(一時停止中)$fe";
$nosubmit = " OnKeyPress='if(event.keyCode==13){return false;}'";
$nosubmit2 = "onclick='this.disabled=true;'";
$null = "<img src='$idir/null.gif' width=1 height=1 title=''>";
$table0 = "<table cellpadding=0 cellspacing=0 class='doc131' border=0 width='100%'>";
$table1 = "<table cellpadding=0 cellspacing=0 class='doc131' border=0>";
$clip = "<img src='$idir/clip.gif' height=10 width=17 title='添付ファイルがあります' border=0>";
$mail = "<img src='$idir/mail.gif' height=14 width=19 align='top' title='未読メッセージがあります.' border=0>";
$print = "<a href='javascript:window.print();'><img src='$idir/print.gif' height=20 width=20 title='この画面を印刷します' border=0></a>";
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$year = $year+1900; $month = $mon+1;
foreach (qw(month mday min hour sec)){$$_ = sprintf("%02d",$$_);}
%m = (Jan,1,Feb,2,Mar,3,Apr,4,May,5,Jun,6,Jul,7,Aug,8,Sep,9,Oct,10,Nov,11,Dec,12);
%w = (Mon,'月',Tue,'火',Wed,'水',Thu,'木',Fri,'金',Sat,'土',Sun,'日');
&getenv('config.local.cgi','=',1);
$ttl = 1800 if !$ttl;
$groot = $mailroot.'/groups';
$ip = $ENV{'REMOTE_ADDR'}; if ($strict == 1){$ip =~ s/\.\d+$//;}; $ip =~ s/[.:]//g;
$IIS = 1 if $ENV{'SERVER_SOFTWARE'} =~ /IIS/;
$OS = $^O;
$OS = '' if $OS =~ /MSWin/;
@k4array = qw(k4login k4allowallow k4allowdeny k4allowantispam k4allowmail k4allownotify k4allowusertab 
	k4allowdistribute k4allowbigfile k4allowbigfile2 k4autoreply k4fixed k4forward k4fservice k4menu k4mklist
	k4mlist k4password k4popsync k4fsallow k4fssize k4fsspace k4fsfolders k4fsfiles k4fsitem k4bbshandle 
	k4xenable k4xenableconfig k4xouturl k4xtopmenu k4xsearch k4xusecal k4xshowheader k4xshortening k4xitem 
	k4xmaxmsgfile k4xallowrest k4xadlimit k4xmsgslimit k4xmsgvlimit k4xsiglimit k4xsigrowmax k4xviewimage 
	k4xviewlog k4xallowattach k4xattachmax k4xattachsize k4xfolderlimit k4xdeltrash 
	Attachment AutoReply Allow Deny Log NotifyFrom NotifyTo NetBIOSName Distribute);
@xmailarray = qw(RealName CompanyName HomePage Address Telephone MaxMBSize MaxMessageSize SmtpPerms 
	ReceiveEnable PopEnable DisableEmitAuthUser);
@ARGV = split(/\+/,$ENV{'QUERY_STRING'});

#------------------------------------------
## 認証 extstr1:ファイル管理 extstr2:所属グループ extstr3:管理グループ extstr4:閲読掲示板
sub auth {
	($key4,$key5,$key6,$key7,$key8,$key9,$key10,$key11) = @ARGV if @ARGV;
	my ($cData,$cName,$cookie,$loginOK,@cookie);
	@cookie = split(/;\s*/,$ENV{'HTTP_COOKIE'});
	@cookie = grep(/^$k4cookiestr1=/,@cookie);
	$cookie = pop(@cookie);
	($cName,$cData) = split(/=/,$cookie);
	$cData =~ tr/gxoAdBjCqDEw\/FpGeHnIhJuKaLyMiNvOkPcQzRtSmTfUrVlWsXYZ0123456789b/abcdefg0123456789hijkl|mnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ/;
	$cData =~ s/\:\d*\|/:/g;
	($extstr,$domain1,$user1,$loginid,$crypt,$etime,$ip0,$extstr1,$extstr2,$extstr3,$extstr4,$extstr5) = split(/:/,$cData);
	$userdir = "$mailroot/domains/$domain1/$user1";
	if (-f "$userdir/$xmailcfg/$crypt.crypt"){
		return(1) if $_[0] eq 'confirmmylogin';
		$k4fixed = 1 if $etime =~ s/_k4fixed_//;
		$Expired = 1 if time() > $etime;	# if expired?
		$dummy = rand(time());
		$loginOK = 1;
		return() if $key4 eq 'k4logout';		# when logout(menu.cgi,menu1.cgi)
	}
	if ($loginOK){
		if ($strict && $ip0 ne $ip && $key4 ne 'k4logout'){
			&log('r',$domain1,$user1,'*','run',"ログイン後のIPアドレスの不一致",$0,$crypt);
			&redirect();
		}
		($k4fsallow,$k4fssize,$k4fsspace,$k4fsfolders,$k4fsfiles,$k4fsitem,$k4bbsallow) = split(/_/,$extstr1);
		($k4xenable,$k4xenableconfig,$topmenu,$search,$usecal,$showheader,$shortening,$item,$maxmsgfile,
		$allowrest,$adlimit,$msgslimit,$msgvlimit,$siglimit,$sigrowmax,$viewimage,$allowattach,$attachmax,
		$attachsize,$folderlimit,$allowbigfile,$allowbigfile2) = split(/_/,$extstr2) if $extstr2 =~ /^1_/;
		return();
	} else {
		return() if $_[0] eq 'confirmmylogin';
		&log('r',$domain1,$user1,'?','run','不正ログインまたはセッション強制終了',$0,$crypt);
		&redirect();
	}
}

## 正規表現チェック(簡易)
sub chk_regexp {
	my ($str) = @_;
	
	$str =~ s/\\[A-Z.()\[\]?*@\/|]//gi;
	$str =~ s/\\//g;
	$str =~ s/\.+[?*]\?*//g;
	$str =~ s/^[\^?*]+//;
	$str =~ s/\$+$//;
	return(1) if $str =~ /\//;
	
	# ()[]表現
	1 while $str =~ s/\[[^\[\]]*\]//;
	return(2) if $str =~ /[\[\]]/;
	1 while $str =~ s/\([^()]*\)//;
	return(3) if $str =~ /[()]/;
	
	return(0);
}

## コントロールコマンド実行
sub ctrlcmd {
	my ($cmd) = @_;
	&error('e521',$ermsg1) if (!$admin || !$pass);
	my $admin = &dec_str($admin);
	my $pass = &dec_str($pass);
	$ctrlprt = 6017 if !$ctrlprt;
	$smtpsvr = 'localhost' if !$smtpsvr;
	my $ctrlcmd;
	if ($OS){		# MSWin以外
		$xmaildir =~ s/\\/\//g;
		$ctrlcmd = "$xmaildir/$ctrlclnt";
	} else {
		$xmaildir =~ s/\//\\/g;
		$ctrlcmd = "$xmaildir\\$ctrlclnt.exe";
	}
	system("$ctrlcmd -s $smtpsvr -n $ctrlprt -u \"$admin\" -p \"$pass\" $cmd");
}

## MSG bodyデコード
sub dec_body {
	my ($body,$type,$qp,$dec,$charS) = @_;
	if ($charS =~ /^csISO.?2022.?JP/i){$charS = $charsetM;}		# cs****はEncodeモジュールで対応不可
	elsif ($charS =~ /^csShift.?JIS/i){$charS = $charsetS;}
	$body =~ s/^\s+//;
	$body =~ s/\s+$//;
	if ($qp){$body = &dec_qp($body);}
	elsif ($dec){$body = MIME::Base64::decode($body);}
	#$body = &dec_utf($body,$charS);		# $charSを評価すると誤動作の場合あり(2014/08/25)
	$body =~ s/[\x00-\x08\x0B-\x0C\x0E-\x1A\x1C-\x1F]/?/g;		# 制御コードは?に(09,0A,0D,1Bを除く)
	$body = &dec_utf($body);
	$htmltmp1 .= $body if $type eq 'html';		# htmltmp1 は HTML メールとしてファイル保存
	$body;
}

## quoted-printableデコード
sub dec_qp {
	my ($data) = @_;
	$data =~ s/=\r*\n//g;
	$data =~ s/=\r//g;
	$data =~ s/=([0-9A-Fa-f]{2})/pack("C",hex($1))/ge;
	$data;
}

## 文字列をXMailデコード
sub dec_str {
	my ($str1) = @_;
	my $str2;
	while ($str1 =~ s/^(.)(.)//){
		my ($s1,$s2) = ($1,$2);
		$s1 =~ tr/01234567/67452301/;
		$s2 =~ tr/54761032dcfe98ba/0123456789abcdef/;
		$str2 .= chr(hex("$s1$s2"));
	}
	$str2;
}

## 文字コードを判定してUTF-8フラグをつける
sub dec_utf {
	my ($str,$enc) = @_;
	if (!$enc){						# コード指定がない場合は判定
		my $enc2 = guess_encoding($str);
		if ($enc2 =~ /^[\-\w]+ +or +([\-\w]+)/){		# xxx or yyyy なら後者を取る
			$enc2 = $1;
		} elsif (!ref($enc2)){		# 判定不能(どれにもマッチしない)ならISO-2022-JPとする
			$enc2 = $charsetM;
		}
		$enc = $enc2;
	}
	$str = decode($enc,$str);		# UTFデコード
	$str;
}

## 添付ファイル残骸の始末
sub delattach {
	my $dir = "$tempdir/$loginid/upload";
	if (-d $dir){while (glob("$dir/*")){unlink($_);}}
}

## 終了時ゴミ掃除
sub deltrash {
	my ($dir,@dirlist);
	$dir = '../temp';
	$ttl = 7200 if !$ttl;
	opendir(DIR,$dir);
		@dirlist = readdir(DIR);
	closedir(DIR);
	foreach (@dirlist){
		rmtree(["$dir/$_"],0,0) if (-d "$dir/$_" && length($_) > 40 && (stat("$dir/$_"))[9] < time() - $ttl);
	}
	$dir .= '/bigfile';
	opendir(DIR,$dir);
		@dirlist = readdir(DIR);
	closedir(DIR);
	foreach (@dirlist){
		rmtree(["$dir/$_"],0,0) if (-d "$dir/$_" && length($_) == 32 && (stat("$dir/$_"))[9] < time() - $ttl);
	}
}

## 管理対象ドメインのリストを得る
sub domainadmin {
	my ($user,$domain,$ext) = @_;
	if (!$user){$user = $user1;}
	if (!$domain){$domain = $domain1;}
	my @admin;
	
	open(MyFILE,"$mailroot/$domainadmintab") || return();
		while(<MyFILE>){
			$_ = &dec_utf($_,$charsetE);
			chomp;
			s/"//g;
			if (/^&* *([^\t, ]+)[\t, ]+$user\@$domain/i){
				if (!grep(/^$1$/,@admin)){push(@admin,$1);}
			}
		}
	close(MyFILE);
	
	@admin = sort(@admin);
	if ($ext){return @admin;}
	
	if (!@admin){
		&log('r',$domain,$user,'?','run','認証後に権限なし実行',$0);
		&redirect();
	}
}

## ファイルをダウンロード(クライアントOS情報を得て文字コードセットを推定)
sub download {
	my ($file,$realname) = @_;
	my ($agent,$charS,$stat) = (lc($ENV{'HTTP_USER_AGENT'}),'Shift_JIS',1);
	
	if ($agent =~ /(cygwin|darwin|mac|mswin|win\d|windows)/ || $agent eq ''){;}
	elsif ($agent =~ /netware/){$charS = $charset;}
	elsif ($agent){$charS = $charsetE;}
	
	Encode::_utf8_off($realname);
	Encode::from_to($realname,$charset,$charS) if ($agent !~ /firefox/ && $charS ne $charset);
	$realname = time().'.bin' if !$realname;
	
	print "Content-Type: application/download\n";
	print "Content-Disposition: attachment; filename=\"$realname\"\n\n";
	if (open(FILE,"<$file")){
			binmode FILE;
			binmode STDOUT;
			print while (<FILE>);
		close(FILE);
		$stat = 0;
	}
	
	$stat;
}

## メールアドレスチェック(抜き出し)
sub emchk {
	my ($tmp) = @_;
	my ($tmp1,$tmp2);
	1 while $tmp =~ s/"[^<>]+"//g;
	1 while $tmp =~ s/\(.*?\)//g;
	$tmp =~ s/["\s]+//g;
	
	foreach (split(/[;,] */,$tmp)){
		if (/^[^<]*<+([^>]+)/){$tmp1 = $1;}
		else {$tmp1 = $_;}
		if ($tmp1 && $tmp1 !~ /^$emreg1$/i){return('error',$_);}
		$tmp2 .= "$tmp1,";
	}
	$tmp2 =~ s/,+$//;
	$tmp2;
}

## 文字列(Subject, メールアドレス等)のBase64エンコード、折り返し
sub enc_base64 {
	local($str) = @_;
	
	if ($str =~ /[^$zstr]/){		# 2バイト文字が含まれるならエンコード
		Encode::_utf8_off($str);
		$str = encode("MIME-Header",decode($charset,$str));
	} else {						# 1バイト文字のみならワード単位の折り返し
		my ($length1,$length2) = (76,67);
		my ($c,$tmp,$tmp2);
		$str =~ s/\s+,\s*/, /g;
		foreach my $word (split(/\s+/,$str)){ 
			$tmp .= $word.' ';
			if (!$c){
				if (length($tmp) >= $length1){
					$tmp2 = $tmp."\n";
					$tmp = '';
					$c++;
				} else {
					$tmp2 = $tmp;
				}
			} elsif (length($tmp) >= $length2){
				$tmp2 .= $tmp."\n";
				$tmp = '';
			}
		}
		$tmp2 =~ s/^\s+//;
		$tmp2 =~ s/[\n\r\s]+$//;
		$tmp2 =~ s/\n+/\n  /g;
		$str = $tmp2;
	}
	
	$str;
}

## 文字列をXMailエンコード
sub enc_str {
	my ($str1) = @_;
	my $str2;
	while ($str1 =~ s/^(.)//){
		my $s0 = unpack("H2",$1);
		$s0 =~ /(.)(.)/;
		my ($s1,$s2) = ($1,$2);
		$s1 =~ tr/67452301/01234567/;
		$s2 =~ tr/0123456789abcdef/54761032dcfe98ba/;
		$str2 .= "$s1$s2";
	}
	$str2;
}

## エラー表示
sub error {
	my $title = $fs7R.'エラー発生: <b>'.$_[0].'</b>'.$fe;
	
	print "Content-type: text/html; charset=$charset\n\n";
	print "<html><head>$charcss</head>";
	
	$K4 = <<"EOF";
<body bgcolor='#ffffff' class='doc131'>
<table width='100%' height='90%'>
<tr><td align='center'>
	<table class='doc131'>
	<tr><td><img src='$idir/foot_1.gif' width=160 height=154 title='Welcome' border=0></td>
	<td width=10></td>
	<td width=200>$title
	$hr
	$_[1]<br>
	<p>おそれいりますが、<br>
	管理者 $postmaster までご連絡ください。</p></td></tr>
	</table></td></tr>
</table>
</body>
</html>
EOF
	&print_utf($K4);
	&exit();
}

## 終了処理
sub exit {
	&deltrash();
	exit;
}

## 時間切れ
sub expire {
	&logout(1);
	&deltrash();
	local ($msg,$opt) = @_;
	require './expired.cgi';
	exit;
}

## サブディレクトリのリストを得る
sub getdirs {
	my ($dir,$regexp) = @_;
	$regexp = '.*' if !$regexp;
	
	my (@dirlist,@tmp);
	opendir(DIR,$dir);
		@dirlist = readdir(DIR);
	closedir(DIR);
	foreach (@dirlist){
		if (-d "$dir/$_" && /^$regexp$/i){push(@tmp,$_);}
	}
	
	@tmp;
}

## ドメイン別ログアウト先を得る
sub getdomainurl {
	local($domain,$a,$b) = @_;
	my %i;
	
	open(MyFILE,"$mailroot/domains/$domain/k4.url.tab") || return();
		while(<MyFILE>){
			chomp;
			if (/^[\s#]*$/ || !/=/){next;}
			($a,$b) = split(/ *= */,"$_");
			if ($a =~ /\W/i || !$b){next;}
			$i{$a} = $b;
		}
	close(MyFILE);
	
	$i{'outurl'};
}

## 設定ファイル(config.tab/user.tab/config.local.cgiなど)から変数を入手
sub getenv {
	my ($file,$char,$op,$op2,$charSet) = @_;	# $op=''で連想配列で返す、$op2=1で#以降を削除しない
	$char = '\t' if !$char;		# $charSetはファイルの文字コードを指定する場合、指定しない場合はguess_encodingで判定
	my @temp; my %temp;
	
	if (open(MyFILE,$file)){
			@temp = <MyFILE>;
		close(MyFILE);
	} elsif ($op){
		return();
	} else {
		&error('e522',$ermsg1);
	}
	
	foreach(@temp){
		$_ = &dec_utf($_,$charSet);
		chomp;
		s/^[\s"]+//;
		next if (/^\W/ || /^\s*$/);
		my ($name,$value) = split(/"* *$char */,$_,2);
		if (!$op2 && $name ne 'Tag' && $name ne 'pass' && $name ne 'ForceFrom'){
			$value=~s/\s*#.+//; $value=~s/[\s"]+$//; $value=~s/^["\?]+//;
		}
		if ($name eq 'smtpsvr'){$value =~ s/[\s,].*//;}
		if ($op){$$name = $value;}
		$temp{$name} = $value;
	}
	
	return(%temp) if !$op;
}

## 追加フォルダのリストを得る
sub getfolders {
	my @tmp;
	open(MyFILE,"$userdir/$xmailcfg/folder.tab") || return();
		while(<MyFILE>){
			$_ = &dec_utf($_,$charsetE);
			chomp;
			if (!/\t/ || /^[^io]/i || /^[ \t"]*$/){next;}
			s/</&lt;/g;
			s/>/&gt;/g;
			s/"/&quot;/g;
			push(@tmp,$_);
		}
	close(MyFILE);
	@tmp;
}

## 強制付加メッセージフッタを得る
sub getmsgfooter {
	my ($file) = @_;
	my $footer;
	
	open(FILE,$file) || return();
		while(<FILE>){
			$_ = &dec_utf($_,'JIS');
			#Encode::from_to($_,$charset,'jis');
			$footer .= $_;
		}
	close(FILE);
	
	$footer =~ s/^\s+//;
	$footer =~ s/%user%/$user1/g;
	$footer =~ s/%domain%/$domain1/g;
	$footer =~ s/[\n\s]*$/\n/;
	$footer;
}

## 自動ログイン用ショートカットを作成
sub get_my_shortcut {
	my ($domain,$user) = @_;
	my ($pass,$str);
	
	my ($domain2,$user2) = (lc($domain),lc($user));
	if (open(FILE,"$mailroot/mailusers.tab")){
			while (<FILE>){
				chomp;
				s/"//g;
				$_ = lc($_);
				my @tmp = split(/\t/,$_);
				if ($tmp[0] eq $domain2 && $tmp[1] eq $user2){
					$pass = $tmp[2];
					$str = "$user2\@$domain2";
					last;
				}
			}
		close(FILE);
	}
	return () if !$pass;
	
	$pass = md5_hex $pass;
	$str  = md5_hex $str;
	return("login.cgi?login+$str+$pass") if ($pass && $str);
}

## ログアウト先URLを得る
sub getouturl {
	my ($domain) = @_;
	my $file = 'K4.url.tab';
	my $url;
	
	# ログアウト先の優先度: 個人 => グループ => ドメイン
	my %i = &getenv("$userdir/$xmailcfg/config.tab",'=');	# 個人環境を得る
	$url = $i{'k4xouturl'} if ($i{'k4xenable'} && $i{'k4xouturl'});
	
	# グループのログアウト先を得る
	if (!$url && $extstr3){
		foreach my $u (split(/_+/,$extstr3)){
			$u =~ s/^[A-Z]//;
			next if !-f "$groot/$u/$file";
			my %g = &getenv("$groot/$u/$file",'=');
			$url = $g{'outurl'} if ($g{'outurl'} && !$url);
		}
	}
	
	# ドメインのログアウト先を得る
	if (!$url && -f "$mailroot/domains/$domain/$file"){
		my %d = &getenv("$mailroot/domains/$domain/$file",'=');
		$url = $d{'outurl'} if $d{'outurl'};
	}
	
	$url = $outurl if !$url;
	$url;
}

## 半角カタカナ=>全角変換
sub hanzen {
	foreach(@_){
		Encode::_utf8_off($$_);		# これがないとwide caractoerエラーとなる
		Encode::from_to($$_,$charset,$charsetE);	# 一時EUCにする
		Encode::JP::H2Z::h2z(\$$_);
		Encode::from_to($$_,$charsetE,$charset);	# 変換
		#$$_ = encode($charset,$$_);					# UTF-8にもどす
		Encode::_utf8_on($$_);
	}
}

## HTML表示用に変換
sub htmlconv {
	foreach(@_){
#		$$_ =~ s/&/&amp;/g;
		$$_ =~ s/</&lt;/g;
		$$_ =~ s/>/&gt;/g;
		$$_ =~ s/"/&quot;/g;
	}
}

## リスト管理情報を得る
sub listadmin {
	my ($user,$domain,$list) = @_;
	my ($tmp,$tmp1,@tmp);
	$tmp = "$user\@$domain";
	$tmp =~ s/[.\-\@]/\\$&/g;
	$list =~ s/[.\-\@]/\\$&/g;
	if (open(MyFILE,"$mailroot/$listadmintab")){
			while(<MyFILE>){
				$_ = &dec_utf($_,$charsetE);
				chomp;
				@tmp = split(/\t/,$_);
				if ($tmp[0] =~ /^$emreg$/ && $tmp[1] =~ /^$tmp$/i){
					if ($tmp[0] =~ /^$list$/){$tmp1 = $_;}
					push(@listadmin,$_);
				}
			}
		close(MyFILE);
	}
	if ($list && !$tmp1){&redirect;}
	($Lname,$Ladmin,$Lmember,$Lmsgsize,$Lstag,$Lattach,$Lmsgid,$Lheader,$Ldeny,$Lrobot,$Ldel,
		$Lfrom,$Lsubscribe,$Llog,$Larc) = split(/\t/,$tmp1);
}

## ロギング
sub log {
	if (!$logging){return();}
	my ($stat,$domain,$user,$pass,$type,$desc,$file,$str1) = @_;
	my $wday = ('日','月','火','水','木','金','土')[$wday];
	my $logfile = "$mailroot/logs/k4-$year$month$mday".'0000';
	my $op = "$ENV{'REMOTE_ADDR'}/$ENV{'HTTP_USER_AGENT'}";
	if ($pass =~ /\*+/){$pass = '*****';}
	if ($stat =~ /^f$/i){$stat = 'Failure';}
	elsif ($stat =~ /^r$/i){$stat = 'Redirect';}
	elsif ($stat =~ /^s$/i){$stat = 'Success';}
	else {$stat = 'FYI';}
	$file = $1 if $file =~ /\/cgi\/([^\/]+)$/i;
	my $line = join("\t","$year/$month/$mday($wday) $hour:$min:$sec",$stat,$domain,$user,$pass,$type,$desc,$file,$op,$str1);
	
	Encode::_utf8_off($line);
	Encode::from_to($line,$charset,$charsetE);
	if (open(MyFILE,">>$logfile")){
			flock(MyFILE,2);
			print MyFILE "$line\n";
		close(MyFILE);
	}
}

## ログアウト時処理
sub logout {
	if (-e "$tempdir/$loginid"){rmtree(["$tempdir/$loginid"],0,0);}
	if ($_[0]){return();}
	unlink("$userdir/$xmailcfg/$crypt.crypt");
	foreach (glob("$mailroot/logs/K4/$user1\@$domain1*")){unlink($_);}
}

## メールボックス使用量チェック
sub mailbox_check {
	&getenv("$userdir/user.tab",'',1);
	if ($MaxMBSize eq ''){$MaxMBSize = $maxmbsize;}
	if ($ReceiveEnable eq ''){$ReceiveEnable = 1;}
	
	my ($size,@dirlist);
	opendir(DIR,$userdir);
		@dirlist = readdir(DIR);
	closedir(DIR);
	foreach (@dirlist){
		next if /\.|$xmailcfg|logs|temp\d*/i;
		find(sub {$size += -s if -f}, "$userdir/$_");
	}
	if ($size){
		$size = int($size / 1000);
		if ($size == 0){$size = 1;}
	}
	
	if (!$ReceiveEnable){
		$mboxcaution = 3;
		$mbcmsg = $fs7R.'メッセージの送信は許可されていません !!'.$fe.'<br>';
		$mbcmsg .= "詳細は管理者までお問い合わせください。";
	} elsif ($MaxMBSize <= $size){
		$mboxcaution = 2;
		$mbcmsg = $fs7R.'メールボックスがいっぱいです !!'.$fe.'<br>';
		$mbcmsg .= "トレイやフォルダ、ごみ箱の不要メッセージを削除してください。";
	} elsif ($MaxMBSize - $size < $spacemin){
		$mboxcaution = 1;
		$mbcmsg = $fs5R.'メールボックスの残りスペースがあとわずかです！'.$fe.'<br>';
		$mbcmsg .= "スペースがなくなるとメッセージの送受信ができなくなります。<br>";
		$mbcmsg .= "不要メッセージを削除してください。";
	}
	$size;
}

## 改ページリンクを作成
sub makelink {
	local ($cgi,$op1) = @_;		# $op1 は最大MSGを制限しない場合
	local ($c1,$c2,$c3,$key) = ("$cgi","$key5+$key6+$key7+$key8",$total,"");
	$item = 10 if !$item;
	if (!$op1 && $maxmsgfile && $c3 > $maxmsgfile){$c3 = $maxmsgfile;}
	if ($c3 > $item*$key4+$item){
		$key = $key4 + 1;
		if ($c3-$key*$item < $item){$item1 = "残りの". ($c3-$key*$item) ."件";} else {$item1 = "次の".$item."件";}
		$left = "&nbsp;&nbsp;<a href='$c1?$key+$c2'>$item1</a>$arrowR&nbsp;";
		if ($c3 > $item*$key4+$item*2){
			$key = int($c3/$item);
			if ($key*$item != $c3){} else {$key--;}
			$left = "$left<a href='$c1?$key+$c2'>末尾へ</a>$arrowR$arrowR&nbsp;";
		}
	}
	if ($key4){
		$key = $key4 - 1;
		$left = "$arrowL<a href='$c1?$key+$c2'>前の".$item."件</a>$left";
		if ($key4 > 1){$left = "$arrowL$arrowL<a href='$c1?0+$c2'>先頭へ</a>&nbsp;$left";}
	}
	$left;
}

## 閲覧許可MLを得る
sub mlist_check {
	my @tmp;
	foreach(split(/\s+/,$k4mlist)){
		my ($name,$domain) = split(/@/,$_);
		if (-d "$mailroot/domains/$domain/$name"){push(@tmp,$_);}
	}
	@tmp;
}

## 正規表現メタ文字列ほかをエスケープ処理
sub mod_str {
	my @str = @_;
	my @tmp;
	foreach(@str){
		s/["$()*+\-.\/?@\[\\\]{|}]/\\$&/g;
		push(@tmp,$_);
	}
	@tmp;
}

## インデックス用メッセージリストを作成
sub msg_list {
	my @all = @_;
	local($charS,$date,$file,$from,$line,$rto,$rpath,$subject,$to,@reg);
	$msgvlimit = 10000 if (!$msgvlimit || $msgvlimit < 10000);
	my @tmp;
	
	foreach $file (@all){
		chomp($file);
		my ($boundary,$tmp);
		open(MyFILE,$file) || next;
			while(<MyFILE>){
				$tmp .= $_;
				last if length($tmp) > $msgvlimit*5;
			}
		close(MyFILE);
		
		my ($header,$body) = split(/\n\n+/,$tmp,2);		# ヘッダとボディに分割
		$header =~ s/ *\r*\n[ \t]+//g;
		if ($header =~ /boundary="*([^";\r\n]+)/i){
			$boundary = $1;
			$boundary =~ s/$bnreg/\\$&/g;
		}
		$charS = $2 if $header =~ /(charset=)+["']?([\w\-]+)/i;
		if ($header =~ /Content-Type:.+(file)*name=['"]*.+/ ||
			$header =~ /Content-disposition:.+(file)*name=['"].+/){$boundary = $clip;}
		elsif ($boundary && $body =~ /-+$boundary\n(.+\n)*.+name\**\d*\**=/i){$boundary = $clip;}
		elsif ($boundary){
			foreach my $i (split(/-+$boundary-*\n/,$body)){
				my ($p1,$p2) = split(/\n\n+/,$i,2);
				if ($p1 =~ /boundary\**="*([^"; \r\n]+)/i){
					my $b1 = $1;
					$b1 =~ s/$bnreg/\\$&/g;
					foreach (split(/-+$b1-*\n/,$p2)){
						my ($p3,$p4) = split(/\n\n+/,$_,2);
						if ($p3 =~ /name\**\d*\**=/i){$boundary = $clip; last;}
					}
					last if $boundary eq $clip;
				} elsif ($p1 =~ /Content-Type: *image\/(gif|jpe*g*|png)/i){
					$boundary = $clip;
					last;
				}
			}
			$boundary = '' if $boundary ne $clip;
		}
		my %h = &parse_header($header,$charS);		# ヘッダ情報を得る
		($date,$from,$rto,$rpath,$subject,$to) = 
			($h{'date'},$h{'from'},$h{'reply-to'},$h{'return-path'},$h{'subject'},$h{'to'});
		if (!$date && $h{'received'} =~ /;\s*(.+)/){$date = $1;}
		my ($date1,$size,$stamp) = &parse_msg($date,$file);
		
		foreach(qw(from rto rpath to)){
			if ($$_ =~ /^\s*<([^>]+)>\s*$/){$$_ = $1;}
			$$_ =~ s/,\s*/, /g;
			if (length($$_) > 50){$$_ =~ s/([^\s]{24}[^.,<>@\-_ ]*[.,<>@\-_])(...)/$1 $2/g;}
		}
		
		if (!$from){
			$from = "($rpath)" if $rpath;
			$from = "($rto)" if $rto;
			$from = '(なし)' if $from eq '';
		}
		if (!$to){$to = '(なし)';}
		if (!$subject){$subject = '(無題)';}
		if (length($subject) < 6){$subject .= "　　　\&nbsp;";}
		
		$file = $& if $file =~ /[^\/]+$/;
		$line = "$subject\t$from\t$to\t$date1\t$file\t";
		&htmlconv('line');
		$line .= "$size\t$boundary\t$stamp";
		
		push(@tmp,"$line\n");
	}
	
	@tmp;
}

## フォーム入力を処理
sub parse_form {
	my @array = @_;
	
	my $cgi = new CGI_Lite;
	$cgi->set_platform ('Windows');
	my %k4 = $cgi->parse_form_data();
	foreach (@array){
		$$_ = $k4{$_};
		$$_ = &dec_utf($$_,$charset);
		$$_ =~ s/\r\n/\n/g;
		$$_ =~ s/\r/\n/g;
	}
}

## ヘッダ解析
## (おそらくスパマー諸氏によるものであろう)行儀の悪いヘッダの解析で迷宮の森を彷う状況が何年も続いたが、
## ついにQuotedPrintableとBase64のデコードを見境なく行うのが一番確実と判断し闘争史の幕を閉じた(2014/07/09)
sub parse_header {
	local ($header,$chars) = @_;
	local ($key,$val,%h);
	
	foreach (split(/\r*\n/,$header)){
		($key,$val) = split(/:\s*/,$_,2);
		$val =~ s/=\?[^?]+\?Q\?([^?]*)\?=/&dec_qp($1)/egio;		# 乱暴な!
		$val =~ s/$ewreg/decode_base64($3)/egio;				# 乱暴な!(しかし結果OK)
		#my $code = $2;
		#$val = &dec_utf($val,$code);
		$val = &dec_utf($val);					# コード判断はEncode::Guessに任せる(やれやれ)
		$val =~ s/[\x00-\x1F]|\\x\w\w/ /g;		# 制御コード・16進表記が残ればスペースに
		$h{lc($key)} = $val;
	}
	
	%h;
}

## Date:フィールド変換、MSGサイズ、MSGタイムスタンプ取得
sub parse_msg {
	my ($date,$file) = @_;
	my ($p1,$p2,$p3,$p4,$p5);
	
	my ($size,$stamp) = ((stat("$file"))[7],(stat("$file"))[9]);
	my $size1 = int(($size+1023)/1024);
	
	if ($date =~ /^([a-z]+), *0*(\d+) +([a-z]+) +(\d+) +(\d+:\d+)/i){
		($p1,$p2,$p3,$p4,$p5) = ($1,$2,$3,$4,$5);
	} elsif ($date =~ /^0*(\d+) *([a-z]+) +(\d+) +(\d+:\d+)/i){
		($p2,$p3,$p4,$p5) = ($1,$2,$3,$4);
	}
	
	if ($p1){$p1 = "($w{$p1})";}
	if ($p2){$date = "$p4/".sprintf("%02s",$m{$p3})."/".sprintf("%02s", $p2)." $p1 $p5";}
	($date,$size1,$stamp);
}

## フッタを追加表示
sub print_footer {
	my ($footer,@tmp);
	if ($_[0] eq 'login'){$footer = '_bottom1.cgi';}
	elsif ($_[0] eq 'relogin' || !$domain1){;}
	else {$footer = '_bottom2.cgi';}
	
	if ($footer && open(MyFILE,$footer)){
			@tmp = <MyFILE>;
		close(MyFILE);
		foreach(@tmp){
			$_ = &dec_utf($_,$charsetE);
			chomp;
			print $_;
		}
	}
	print "<br>\n</body>\n</html>\n";
}

## UTFコンテンツを表示
sub print_utf {
	local ($data,$op1,$op2) = @_;		# $op1=1でutr8_offを行わない、op2=1で改行削除を行わない
	$data =~ s/[\r\n]+\s*//g if !$op2;
	Encode::_utf8_off($data) if !$op1;
	print $data;
}

## リダイレクト処理
sub redirect {
	my ($op1) = @_;
	$op1 = $url if !$op1;
	
	print <<"EOF";
Content-type: text/html

<html><head>
$nocache
<meta http-equiv="Set-Cookie" content="$k4cookiestr1=bye; expires=Thu, 01-Jan-1970 00:00:00 GMT">
<meta http-equiv="Refresh" content="0;url=$op1">
</head></html>
EOF
	exit;
}

## メッセージリストのインデックスを削除する
sub refresh_index {
	my @boxes = @_;
	foreach my $box (@boxes){
		my $str = "msg*-$box*";
		$str = "msg*-*" if $box eq 'all';		# 全削除
		foreach my $list (glob("$userdir/temp/$str")){
			unlink($list);
		}
	}
}

## 再ログイン処理
sub relogin {
	# インデックス削除
	&refresh_index('all');
	# ログインフラグ削除
	unlink("$mailroot/domains/$domain1/$user1/$xmailcfg/$crypt.crypt");
	# ログインURL
	my $url = &get_my_shortcut($domain1,$user1);
	# 自動ログイン
	print "Location: $url\n\n";
	exit;
}

## ユーザ環境(config.tab/user.tab)を更新
sub saveenv {
	my ($char,$xn,$xv,@array,%tmp);
	my $type = shift;
	my $domain = shift;
	my $name = shift;
	my @temp = @_;
	my $file = "$mailroot/domains/$domain/$name";
	
	if ($type =~ /^user/){
		$file .= "/user.tab";
		if ($type eq 'user'){@array = @xmailarray;}
		else {@array = @xmailarraym;}
	} else {
		$char = '=';
		mkdir("$file/$xmailcfg",0755);
		$file .= "/$xmailcfg/config.tab";
		if ($type eq 'k4'){@array = @k4array;}
		else {@array = @k4arraym;}
	}
	if (-f "$file"){%tmp = &getenv($file,$char);}
	foreach(@temp){$tmp{$_} = $$_;}
	
	open(MyFILE,">$file");
		flock(MyFILE,2);
		foreach(@array){
			my $val = $tmp{$_};
			if ($type =~ /^user/){
				if (/RealName|CompayName|HomePage|Address|Telephone/i){if (!$val){$val = '?';}}
				if (/ReceiveEnable|PopEnable/i){if ($val eq ''){$val = 0;}}
				if (/DisableEmitAuthUser/i){if ($val eq ''){next;}}
				Encode::_utf8_off($val);
				Encode::from_to($val,$charset,$charsetE);
				print MyFILE "\"$_\"\t\"$val\"\n";
			} else {
				Encode::_utf8_off($val);
				Encode::from_to($val,$charset,$charsetE);
				print MyFILE "$_ = $val\n";
			}
		}
	close(MyFILE);
}

## アクセス権をセットする(非Windows)
sub set_chmod {
	my ($path,$perm,$op1) = @_;
	return() if !$OS;
	
	#####
	
}

## 所有者をセットする(非Windows)
sub set_chown {
	my ($path,$owner,$op1) = @_;
	return() if !$OS;
	
	return();
	
	$op1 = '-Rf' if !$op1;
	$owner = '###' if !$owner;
	#system("./chown $op1 $owner $path");
}

## RCPT表示を短縮する
sub shortening {
	my ($str1,$str2) = split(/\,+\s*/,$_[0]);
	$str1 .= "<b>,...</b>" if $str2;
	$str1;
}

## 配列を$field番目で$method順ソート
sub sorting {
	my ($field,$method,$type,@reg) = @_;
	
	my @tmp = map {(split /\t/)[$field]} @reg;
	if (!$type){@reg = @reg[sort {$tmp[$a] cmp $tmp[$b]} 0 .. $#tmp];}	# コードで比較
	else {@reg = @reg[sort {$tmp[$a] <=> $tmp[$b]} 0 .. $#tmp];}		# 大小比較の場合
	if ($method){@reg = reverse(@reg);}
	
	@reg;
}

## メッセージ送信
sub startmail {
	local ($vname,$ext,$rname,$size,$mtype,$msgfooter);
	my $boundary = "--${k4name}_20131101_". time();
	my $date = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat')[$wday];
	$date .= ", $mday ".('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec')[$mon];
	my $tza = abs($tz);
	my $tzastr = '-'; $tzastr = '+' if $tz>=0;
	$date .= " $year $hour:$min:$sec ". $tzastr . sprintf("%02s",$tza) . '00';
	my ($from1,$rto1) = ($from,$RTo);		# from1,rto1 は MAIL FROM, Return-Path用
	if ($from1 =~ /^[^<]*<(.+)>/ || $from1 =~ /^([^\(]+)\(.+\)/){$from1 = $1;}
	if ($rto1 =~ /^[^<]*<(.+)>/ || $rto1 =~ /^([^\(]+)\(.+\)/){$rto1 = $1;}
	my $messageid = sprintf("%X",time) . sprintf(sprintf("%%0%XlX",6),int(rand(0xffffff)));
	
	foreach(qw(inreplyto msgid references)){
		$$_ =~ s/\s//g;
		$$_ =~ s/.+/<$&>/;
		$$_ =~ s/,/></g;
	}
	if ($references){$references = "References: $references$msgid";}
	elsif ($inreplyto){$references = "References: $inreplyto$msgid";}
	elsif ($msgid){$references = "References: $msgid";}
	if ($msgid){$inreplyto = "In-Reply-To: $msgid";} else {$inreplyto = '';}
	
	# SubjectのBase64エンコード、折り返し
	$subject = &enc_base64($subject);
	
	# Cc,From,Reply-To,ToのBase64エンコード
	foreach(qw(Cc RTo from to)){
		my $str;
		foreach my $tmp (split(/,/,$$_)){
			$tmp = &enc_base64($tmp);
			$str .= "$tmp,";
		}
		$$_ = $str;
		$$_ =~ s/[, ]+$//;
		$$_ =~ s/,/$&\n\t/g;	# 1アドレスごとに折り返し
	}
	
	# 強制付加短文
	if ($forcemsgfooter){
		my $tab = "K4.msgfooter.tab";
		# 個人用フッタ
		my $footer = &getmsgfooter("$userdir/$xmailcfg/$tab");
		$message .= "\n$footer" if $footer;
		# グループ用フッタ
		if ($extstr3){
			foreach my $g (split(/_+/,$extstr3)){
				$g =~ s/^[A-Z]//;
				my $footer = &getmsgfooter("$groot/$g/$tab");
				$message .= "\n$footer" if $footer;
			}
		}
		# ドメイン用フッタ
		$footer = &getmsgfooter("$mailroot/domains/$domain1/$tab");
		$message .= "\n$footer" if $footer;
		# 全ユーザ用フッタ
		$footer = &getmsgfooter("$mailroot/domains/$tab");
		$message .= "\n$footer" if $footer;
	}
	
	# 添付ファイルの処理
	my $dir = "$tempdir/$loginid/upload";
	my @FILE;
	my @FILE2;
	foreach my $file (glob("$dir/*.txt")){
		$vname = $ext = $rname = $size = $mtype = '';
		my @tmp;
		open(FILE,$file) || next;
			while (<FILE>){
				$_ = &dec_utf($_,$charset);
				chomp;
				next if /^\s*$/;
				push(@tmp,$_);
			};
		close(FILE);
		($vname,$ext,$rname,$size) = split(/\t/,$tmp[0]);
		next if (!-s "$dir/$vname" || ($size && $attachsize && $size > $attachsize));
		$rname = &enc_base64($rname);
		# 簡易MIME
		$ext = lc($ext);
		if ($ext =~ /^(bmp|gif|png|tiff?)$/){$mtype = "image/$&";}
		elsif ($ext  =~ /^(jpg|jpeg|jpe)$/){$mtype = 'image/jpeg';}
		elsif ($ext =~ /^(html?|shtml|shm|php3?)$/){$mtype = 'text/html';}
		elsif ($ext =~ /^(text|txt|ini)$/) {$mtype = 'text/plain';}
		elsif ($ext =~ /^(xml|xsl)$/){$mtype = 'text/xml';}
		elsif ($ext =~ /^(mpe?ga|mp2|mp3)$/){$mtype = 'audio/mpeg';}
		elsif ($ext =~ /^(kar|midi?)$/){$mtype = 'audio/midi';}
		elsif ($ext eq 'wav'){$mtype = 'audio/x-wav';}
		elsif ($ext eq 'avi'){$mtype = 'video/x-msvideo';}
		elsif ($ext =~ /^mpe?g?$/){$mtype = 'video/mpeg';}
		elsif ($ext =~ /^(mov|qt)$/){$mtype = 'video/quicktime';}
		else {$mtype = 'application/octet-stream';}
		# 添付ファイル情報
		push(@FILE,"$vname\t$rname\t$mtype");
	}
	if (@FILE){unshift(@xheader,"MIME-Version: 1.0\nContent-Type: multipart/mixed;\n\tboundary=\"$boundary\"\n");}
	else {unshift(@xheader,"Content-Type: text/plain; charset=\"$charset\"\nContent-Transfer-Encoding: 7bit\n");}
	push(@xheader,"X-Mailer: $k4name $k4ver\n") if $xmailer;
	push(@FILE2,@xheader) if $o_p_t_1 == 2;
	
	# SMTPセッション開始
	my ($bad,$good,$msg,@rcpt);
	push(@rcpt,@To,@Cc,@Bcc);
	if ($o_p_t_1 == 1){push(@rcpt,$from1);}
	$smtphelo = 'localhost' if !$smtphelo;
	$smtpsvr = 'localhost' if !$smtpsvr;
	$smtpprt = 25 if !$smtpprt;
	
	my $smtp = Net::SMTP->new($smtpsvr, Port=>$smtpprt, Hello=>$smtphelo, Timeout=>10);
	if ($rto1){$smtp->mail($rto1);}
	else {$smtp->mail($from1);}
	foreach(@rcpt){
		if ($smtp->to($_)){$good .= "$_, ";}
		else {$bad .= "$_, ";}
	}
	
	# 送信成功あて先が存在した場合
	if ($good){
		# ヘッダ送信
		$smtp->data();
		$smtp->datasend("Reply-To: $RTo\n") if $RTo;
		$smtp->datasend("Message-Id: <$messageid.$from1>\n");
		$smtp->datasend("Date: $date\n");
		$smtp->datasend("From: $from\n");
		$smtp->datasend("To: $to\n") if $to;
		$smtp->datasend("Cc: $Cc\n") if $Cc;
		$smtp->datasend("$inreplyto\n") if $inreplyto;
		$smtp->datasend("$references\n") if $references;
		$smtp->datasend("Subject: $subject\n") if $subject;
		foreach (@xheader){
			$smtp->datasend("$_");
		}
		$smtp->datasend("\n");
		push(@FILE2,"\n") if $o_p_t_1 == 2;
		
		# ボディ送信
		if ($message){
			if (@FILE){
				$smtp->datasend("--$boundary\nContent-type: text/plain; charset=\"$charset\"\n");
				$smtp->datasend("Content-Transfer-Encoding: 7bit\n\n");
				if ($o_p_t_1 == 2){
					push(@FILE2,"--$boundary\nContent-type: text/plain; charset=\"$charset\"\n");
					push(@FILE2,"Content-Transfer-Encoding: 7bit\n\n");
				}
			}
			Encode::_utf8_off($message);
			foreach my $line (split(/\n/,$message)){$smtp->datasend("$line\n");}
			$smtp->datasend("\n");
			push(@FILE2,"$message\n") if $o_p_t_1 == 2;
		}
		
		# ボディ-添付ファイル送信
		foreach my $line (@FILE){
			my ($vname2,$rname2,$mtype2) = split(/\t/,$line);
			my $str = "--$boundary\nContent-Type: $mtype2\;\n\tname=\"$rname2\"\n";
			$str .= "Content-Transfer-Encoding: base64\nContent-Disposition: attachment\;\n\tfilename=\"$rname2\"\n\n";
			$smtp->datasend("$str");
			push(@FILE2,$str) if $o_p_t_1 == 2;
			open(FILE1,"$dir/$vname2");
				binmode(FILE1);
				while (read(FILE1,$buf,60*57)){
					foreach my $i (split(/\n/,encode_base64($buf))){
						$smtp->datasend("$i\n");
						push(@FILE2,"$i\n") if $o_p_t_1 == 2;
					}
				}
			close(FILE1);
			$smtp->datasend("\n");
			push(@FILE2,"\n") if $o_p_t_1 == 2;
		}
		if (@FILE){
			my $str = "--$boundary--\n";
			$smtp->datasend("$str");
			push(@FILE2,$str) if $o_p_t_1 == 2;
		}
		
		$smtp->dataend();
		$good =~ s/[, ]+$//;
		$msg = "<b>$good</b> あてにメッセージを送りました。";
	}
	
	# SMTPセッション終了
	$smtp->quit;
	
	# 送信不能あて先があった場合
	if ($bad){
		$bad =~ s/[, ]+$//;
		$msg .= "<br><font color='red'><b>$bad</b> は送信できませんでした。</font>";
	}
	
	# 終了処理
	if ($good && $o_p_t_1 == 2){
		# 送信トレイ保存
		$ext = $ENV{'COMPUTERNAME'};
		$ext = 'localhost' if !$ext;
		$ext = lc($ext);
		$file = time . '000.000.' . $ext;
		$header = "Return-Path: <$from1>\n";
		$header .= "Reply-To: $RTo\n" if $RTo;
		$header .= "Message-Id: <$messageid.$from1>\n";
		$header .= "Date: $date\nFrom: $from\nTo: $to\n";
		$header .= "Cc: $Cc\n" if $Cc;
		$header .= "Bcc: $Bcc\n" if $Bcc;
		$header .= "Subject: $subject\n";
		mkdir("$userdir/$outbox",0755);
		
		open(FILE,">$userdir/$outbox/$file") || return();
			flock(FILE,2);
			print FILE $header;
			print FILE @FILE2;
		close(FILE);
		
		$msg .= '<br>送信ずみメッセージが送信トレイにあります。';
		&refresh_index($outbox);
	} elsif ($good && $o_p_t_1 == 1){
		$msg .= '<br>自アカウントにも同報しています。';
		&refresh_index($inbox);
	}
	
	&delattach();
	$msg;
}

## メッセージ送信2(ローカルのメッセージファイルをそのまま送信)
sub startmail2 {
	my ($file) = @_;
	$smtphelo = 'localhost' if !$smtphelo;
	$smtpsvr = 'localhost' if !$smtpsvr;
	$smtpprt = 25 if !$smtpprt;
	
	# セッション開始
	my ($good,$bad,$msg);
	my $smtp = Net::SMTP->new($smtpsvr, Port=>$smtpprt, Hello=>$smtphelo, Timeout=>10);
	$smtp->mail($from);
	foreach(@To){
		if ($smtp->to($_)){$good .= "$_, ";}
		else {$bad .= "$_, ";}
	}
	
	if ($good){
		$good =~ s/[, ]+$//;
		$msg = "<b>$good</b> あてにオリジナルメッセージを転送しました。";
		$smtp->data();
		# ファイルを読んで送信
		open(FILE,$file);
			while (<FILE>){
				$smtp->datasend($_);
			}
		close(FILE);
		$smtp->dataend();
	}
	if ($bad){
		$bad =~ s/[, ]+$//;
		$msg .= "<font color='red'><b>$bad</b> は転送できませんでした。</font>";
	}
	
	# セッション終了
	$smtp->quit;
	$msg;
}

## メッセージ内容を取得
sub view_msg {
	local($body,$b,$bx,$charS,$count,$ctype,$header,$html,$lst,$op1,$text);
	local($dec,$qp,$tmp1,$tmp2);
	my $base64 = 'Content-Transfer-Encoding: *base64';
	my $htmlcontent = 'Content-Type: *text\/html';
	my $qpenc = 'Encoding: *quoted-printable';
	
	my ($box,$file,$op0) = @_;
	if ($box ne 'mlist'){
		my ($box2,$mailbox2) = ($box,$mailbox);
		$box2 =~ s/\//-/g;
		$mailbox2 =~ s/\//-/g;
		if ($op0 ne 'print' && $key9 =~ /_$/ && (!$slogin || $k4fixed)){
			my $idx = "$userdir/temp/msg";
			if ($sortmode && $box2 =~ /^($mailbox2|i\d|o\d|out)/){
				$idx .= "$sortmode-$box2-$key4.lst";
				# 高速表示モード(送受信トレイとそのフォルダのみ)のときは次ページインデックスがない場合がある
				# (一覧終端のメッセージ表示から「次へ」を押した場合)
			} elsif ($key6 eq 'search'){
				$idx .= "-search.lst";
			} else {
				$idx .= "-$box2.lst";
			}
			my @tmp1;
			if (open(MyFILE,$idx)){
					@tmp1 = <MyFILE>;	# <前へ/次へ> からメッセージ表示の場合は
				close(MyFILE);			# インデックスからMSGファイル名を得る
				# ソート
				if ($key8 == 5){@tmp1 = &sorting($key8,0,'num',@tmp1);}
				elsif ($key8 =~ /^[0-3]$/ && $key8 ne ''){@tmp1 = &sorting($key8,0,0,@tmp1);}
				if (!$key5){@tmp1 = reverse(@tmp1);}
				
				my ($tmp2,$tmp3) = split(/_/,$key9);
				if ($sortmode){$tmp2--;}
				else {$tmp2 = $item*$key4 + $tmp2 - 1;}
				$tmp1 = $tmp1[$tmp2];
				chomp($tmp1);
				@tmp1 = split(/\t/,$tmp1);
				if ($key6 eq 'search'){$tmp2 = 5;} else {$tmp2 = 4;}
				$key10 = $file = $tmp1[$tmp2];
			}
		}
		$file = "$userdir/$box/$file";
	}
	my ($c1,@body) = (0);
	open(MyFILE,$file);
		while(<MyFILE>){
			s/[\x0A\x0D]+$//;
			if ($c1 == 0 .. /^$/){
				#chomp;
				$ctype = 1 if /$htmlcontent/i;
				$dec = 1 if /$base64/i;
				$qp = 1 if /$qpenc/i;
				$charS = $2 if /(charset=)+["']?([\w\-]+)/i;
				if (/boundary="*([^";\n\r]+)/i){
					$b = $1;
					$b =~ s/$bnreg/\\$&/g;
				}
				$header .= "$_\n";
				if (length($_) > $maxchars){s/.{10}/$& /g;}
				$headertext .= "$_\n";	# &view_header用
				$c1++;
				next;
			}
			push(@body,"$_\n");
		}
	close(MyFILE);
	
	# ヘッダ部の処理
	$header =~ s/ *\r*\n[ \t]+//g;
	my %h = &parse_header($header,$charS);
	($Bcc,$Cc,$date,$from,$inreplyto,$msgid,$references,$rto,$rpath,$subject,$to,$xmailer)
		= ($h{bcc},$h{cc},$h{date},$h{from},$h{'in-reply-to'},$h{'message-id'},$h{references},$h{'reply-to'},
			$h{'return-path'},$h{subject},$h{to},$h{'x-mailer'});
	if (!$date && $h{received} =~ /;[ \t]*(.+)/){$date = $1;}
	foreach(qw(inreplyto msgid references)){
		$$_ =~ s/\s//g;
		$$_ =~ s/></,/g;
		$$_ =~ s/[<>]//g;
		if ($$_){$xheader .= "<input type='hidden' name='$_' value='$$_'>";}
	}
	foreach(qw(Bcc Cc from rto rpath to)){
		if ($$_ =~ /^\s*<[^>]+>\s*$/){$$_ =~ s/[\s<>]//g;}
		$$_ =~ s/, */, /g;
	}
	($date1,$size,$stamp) = &parse_msg($date,$file);
	if (!$date1){
		$date1 = '(なし)';
		$date1 = $h{'created'} if $h{'created'};		# 下書き/ひな形
	}
	
	if ($xmailer){
		if ($xmailer =~ /^.?K4/i){$xmailer = '';}
		else {$xmailer = ", $xmailer";}
	}
	my ($rto2,$rpath2) = ($rto,$rpath);
	$rto2 =~ s/[.+?*\[\]@]/\\$&/g;
	$rpath2 =~ s/[.+?*\[\]@]/\\$&/g;
	if ($rto && $from !~ /$rto2/i){$rto1 = "(Reply-To: $rto)";} else {$rto = '';}
	if ($rpath && !$rto && $from !~ /$rpath2/i){$rpath1 = "(Return-Path: $rpath)";}
	if (!$subject){$subject = '(無題)';}
	if (!$to){$to = '(なし)';}
	if (!$mailer){$xmailer = '';}
	
	# ボディ部の処理
	$html = $text = '';
	$body = "@body";
	$body =~ s/ *\n /\n/g;
	$body =~ s/^\s+//;
	if ($ctype || $b){
		$body =~ s/^This is a multi-*part message in MIME format\.*\s*//i;
		$body =~ s/^This is multi-*part message\.*\s*//i;
		$body =~ s/^Content-Type: *text\/plain; *charset="*[^"]+"* *; *format="*[^"]+"*\s*//i;
		$body =~ s/^>* *This message is in MIME format\.*(.+\n)*//i;
		$body =~ s/^This is a MIME-encapsulated message\.*\s*//i;
	}
	if ($h{'content-type'} =~ /[\s;]+(file)*name=.+/ || $h{'content-disposition'} =~ /[\s;]+(file)*name=.+/){
		my $tmp = "Content-Type: $h{'content-type'}\n";
		$tmp .= "Content-Transfer-Encoding: $h{'content-transfer-encoding'}\n" if $h{'content-transfer-encoding'};
		$tmp .= "Content-Disposition: $h{'content-disposition'}\n" if $h{'content-disposition'};
		push(@FILES,"$tmp\n$body");
	} elsif ($b){
		my @tmp1 = split(/-+$b-*\n/,$body);				# boundaryで大分割
		splice(@tmp1,99);								# 最大99個を処理
		
		$count = 1;
		foreach(@tmp1){
			my ($charS,$qp,$dec);
			if (/^\n/){$_ = "\n". $_;}
			my ($tmp1,$tmp2) = split(/\n\n+/,$_,2);		# Content-type:とbodyに分割
			$bx = 1 if $tmp1 =~ /name\**=[\n\r\s"']*[^"'\n\r]+|Undelivered *Message|RFC822/i;	# 検索
			$dec = 1 if $tmp1 =~ /$base64/i;
			$qp = 1 if $tmp1 =~ /$qpenc/i;
			$charS = $1 if $tmp1 =~ /charset=["']?([\w\-]+)/i;
			if ($tmp2 =~ /^\s*$/){
				if ($tmp1 =~ /Content-Type:/i){next;}
				elsif ($ctype){$html .= &dec_body($tmp1,'html',$qp,$dec,$charS);}
				else {$text .= &dec_body($tmp1,'text',$qp,$dec,$charS);}
				next;
			}
			if ($tmp1 =~ /\s+boundary="*([^"'\n\r]+)/){
				my $b1 = $1;
				$b1 =~ s/$bnreg/\\$&/g;
				my ($qp,$dec);
				foreach my $tmp3 (split(/-+$b1-*\n/,$tmp2)){
					if ($tmp3 =~ /^\n/){$tmp3 = "\n". $tmp3;}
					my ($tmp4,$tmp5) = split(/\n\n+/,$tmp3,2);
					next if $tmp5 =~ /^\s*$/;
					$dec = 1 if $tmp4 =~ /$base64/i;
					$qp = 1 if $tmp4 =~ /$qpenc/i;
					$charS = $1 if $tmp4 =~ /charset=["']?([\w\-]+)/i;
					if ($tmp4 =~ /\s+boundary="*([^"'\n\r]+)/){
						my $b2 = $1;
						$b2 =~ s/$bnreg/\\$&/g;
						foreach my $tmp6 (split(/-+$b2-*\n/,$tmp5)){
							if ($tmp6 =~ /^\n/){$tmp6 = "\n". $tmp6;}
							my ($tmp7,$tmp8) = split(/\n\n+/,$tmp6,2);
							next if $tmp8 =~ /^\s*$/;
							$dec = 1 if $tmp7 =~ /$base64/i;
							$qp = 1 if $tmp7 =~ /$qpenc/i;
							$charS = $1 if $tmp7 =~ /charset=["']?([\w\-]+)/i;
							if ($tmp7 =~ /name\**\d*\**=[\n\r\s"']*([^"'\n\r]+)|Content-Type: *image\//i){push(@FILES,$tmp6);}
							elsif ($tmp7 =~/$htmlcontent/i){$html .= &dec_body($tmp8,'html',$qp,$dec,$charS) . "\n"; $ctype = 1;}
							else {$text .= &dec_body($tmp8,'text',$qp,$dec,$charS) . "\n";}
						}
					}
					elsif ($tmp4 =~ /name\**\d*\**=[\n\r\s"']*([^"'\n\r]+)|Content-Type: *image\//i){push(@FILES,$tmp3);}
					elsif ($tmp4 =~ /$htmlcontent/){$html .= &dec_body($tmp5,'html',$qp,$dec,$charS) . "\n"; $ctype = 1;}
					else {$text .= &dec_body($tmp5,'text',$qp,$dec,$charS) . "\n";}
				}
			}
			elsif ($tmp1 =~ /name\**\d*\**=[\n\r\s"']*([^"'\n\r]+)|Content-Type: *image\//i){push(@FILES,$_);}
			elsif ($tmp1 =~ /$htmlcontent/i){$html .= &dec_body($tmp2,'html',$qp,$dec,$charS) . "\n"; $ctype = 1;}
			elsif ($tmp1 =~ /(Undelivered) *Message/i || $tmp1 =~ /(RFC822)/i){
				my ($msgfile,$notice);
				if ($tmp1 =~ /Undelivered/i){
					$msgfile = 'Undelivered_Message.txt';
					$notice = 'Undelivered Message';
				} else {
					$msgfile = 'Message_RFC822.txt';
					$notice = 'Message/RFC822';
				}
				if ($allowdown){push(@FILES,"name=\"$msgfile\"\n\n$tmp2");}
				else {
					$text .= "\n===== $notice =====\n\n";
					$text .= &dec_body($tmp2,'text',$qp,$dec,$charS) . "\n";
				}
			}
			else {$text .= &dec_body($tmp2,'text',$qp,$dec,$charS) . "\n";}
		}
	}
	elsif ($ctype){$html = &dec_body($body,'html',$qp,$dec,$charS) . "\n";}
	else {$text = &dec_body($body,'text',$qp,$dec,$charS) . "\n";}
	
	# テキストブロックが空ならHTMLブロック
	if ($text =~ /^\s*(&nbsp;)*\s*$/ && $html){
		$html =~ s/\s+/ /g;
		$html =~ s/&nbsp;/ /g;
		$html =~ s/<html.*?>.*?<body.*?>//i;
		$html =~ s/\s*=\s*/=/g;
		$html =~ s/<!-+.*?-+>//g;				# コメント
		$html =~ s/<style.*?>.*?<\/style>//gi;		# スタイルシート定義
		$html =~ s/<script.*?>.*?<\/script>//gi;		# JavaScript定義
		$html =~ s/<(img|image) [^>]*(alt|title)=['"]([^'">]*)['"].*?>/$3/gi;
		$html =~ s/<(img|image) [^>]+>//g;
		$html =~ s/<a [^>]+>($emreg\?*[\w=&]*)<\/a>/$1/gi;
		$html =~ s/<a [^>]*mailto:($emreg\?*[\w=&]*)[^>]*>/$1/gi;
		$html =~ s/<a .*?href=\W?(https?:[^ "'>]+)[^>]*>\s*(|http[^<]+|$1)\s*<\/a>/$1/gi;
		$html =~ s/<a .*?href=\W?(https?:[^"' >]+)[^>]*>([^<]+)<\/a>/$2 ($1)/gi;
		$html =~ s/\s*(<br|<\/*p|<\/*table|<\/title|<tr|<\/*div|<\/*dl|<\/*dd|<\/*ul|<\/*ol|<\/*h\d|<hr|<li).*?>\s*/\n/gi;
		$html =~ s/\s(<td|<th).*?>/  /gi;
		$html =~ s/<li>/* /gi;
		$html =~ s/<.*?>//g;
		$html =~ s/   +/  /g;
		$html =~ s/^\s+//;
		$html =~ s/\s+$//;
		$html =~ s/ *\n */\n/g;
		if ($html =~ /\S/){
			$text = $html;
			$op1 = "【ご注意】 以下は HTML 形式の本文をテキスト形式に変換したものです。";
		}
	}
	$text =~ s/\r\n/\n/g;		# スペース、改行の処理
	$text =~ s/\r/\n/g;
	$text =~ s/[ \t]+\n/\n/g;
	$text =~ s/\n\n+/\n\n/g;
	$text =~ s/^\s+//;
	$text =~ s/\s+$//;
	
	# 検索処理はここで終了
	if ($op0 eq 'search'){$message = $text; return $bx;}
	
	# 添付ファイル/HTMLメールの処理
	if ($ctype || @FILES){&view_msg_attach();}
	
	# サイズをチェック
	if ($text =~ /^[\n\r\s]*$/){
		$text = "(本文はありません)";
		if ($key9 =~ /^(Fw|Re|Rs)$/){$text = '';}
		$nomsg = 'y';		# 返信/転送/再送信ボタンを表示しないために -> sub do_option
	}
	if ($msgvlimit && $op0 ne 'print' && length($text) > $msgvlimit){
		$text = substr($text,0,$msgvlimit);
		$text =~ s/[\r\n].*$/\n/;
		$op2 = "$fs2【表示制限についてのご注意】$fe ";
		$op2 .= "このメッセージは制限サイズ(半角 $msgvlimit 文字)を超えています。超過分は表示されません。";
		$op2 .= "詳細は管理者に問い合わせてください。<br>";
	}
	
	# 表示用に変換、URLの処理
	$message = $tmp1 = $text;
	$from1 = $from;		# 退避 mailbox_view, mailbox_replyなどで使用
	&htmlconv (qw(from message subject to rpath1 rto1 Bcc Cc xmailer));
	if ($op0 eq 'forward'){return();}
	$tmp1 =~ s/\t/&nbsp; &nbsp; /g;
	$tmp1 =~ s/  / (((&nbsp;/g;
	$tmp1 =~ s/</|_&lt;/g;
	$tmp1 =~ s/>/|_&gt;/g;
	if ($anchor){
		my $emreg = "[\\w.'#\\-]+\@[\\w.\\-]+";
		$tmp1 =~ s/([^=\w])($emreg)/$1<a href='$cginew?$2+100'>$2<\/a>/g;
		$tmp1 =~ s/(ftps?|https?):\/\/[0-9a-z%][!#-'*-;=?\@-{}~]+/<a href='$&' target='_blank'>$&<\/a>/gi;
		$tmp1 =~ s/<a href='(ftps*|https*):\/\/(localhost|192\.|172\.|127\.|10\.).+?>(.+?)<\/a>/$3/gi;
	}
	$tmp1 =~ s/\|_&lt;/&lt;/g;
	$tmp1 =~ s/\|_&gt;/&gt;/g;
	$tmp1 =~ s/\r*\n|\r/<br>/g;
	$tmp1 =~ s/\(\(\((&nbsp;)/$1/g;
	$tmp1 = "<table cellpadding=2 class='doc131' width='100%'><tr><td $bgcolor0>$op1$op2</td></tr></table><br>$tmp1" if ($op1 || $op2);
	$tmp1 .= "<br><br><font class='doc131' $colorR>■制限により以降のデータは表示できません。$fe" if $op2;
	$tmp1 .= "<div align='right'>$arrowU</div>" if ($op0 ne 'print' && length($text) > 1000);
	$htmlmessage = $tmp1;
}

## 添付ファイル/HTMLメールの処理
sub view_msg_attach {
	local($caution0,$count,$data,$fid,$file,$folder,$outfile,$scanok,$tmp,$tmp0,@report);
	my $dir = "$tempdir/$loginid";
	my $tmpname = 'k4image';
	if (!-e $dir){mkdir("$dir",0755);}
	$attach0 = $attach1 = $attach2 = '';	# attach2はインライン表示用
	
	# 添付ファイルの処理
	@alist = ();
	my $c = 1;
	my @fname;		# 同名ファイルチェック用
	while (my $f = shift(@FILES)){
		$file = $nametag = $tmp = '';
		($tmp0,$data) = split(/\n\n+/,$f,2);
		if ($tmp0 =~ /: *quoted-printable/i){
			$data =~ s/=\r*\n//g;
			$data =~ s/=\r//g;
			$data =~ s/=([0-9A-Fa-f]{2})/pack("C",hex($1))/ge;
		}
		foreach my $a (split(/[\n\r]+/,$tmp0)){
			my $str1 = $a;
			$a =~ s/".*?"//g;
			if ($a =~ /"./){$tmp .= "$str1||";}
			else {$tmp .= "$str1\n";}
		}
		$tmp =~ s/\|+\s*//g;
		
		if ($tmp =~ / (filename)(\**|\*\d+\*)=/){$nametag = $1;}
		else {$nametag = 'name';}
		
		if ($tmp =~ /$nametag\** *=/i){
			$tmp =~ s/[\r\n][ \t]+//g if $tmp =~ /(=\?)*($charsetM|$charset)(\?)*/i;
			$file = $1 if $tmp =~ /$nametag\** *= *"*([^"\n\r]+)/i;
			$file =~ s/=\?csISO.?2022.?JP\?/=?$charsetM?/ig;
			$file =~ s/=\?csShift.?JIS\?/=?$charsetS?/ig;
			if ($file =~ /^$charsetM''(\%.+)/i){
				$file = $1;
				$file =~ s/%([0-9a-fA-F][0-9a-fA-F])/chr(hex($1))/ego;
			} elsif ($file =~ s/=\?$charset\?q\?([^?]*)\?=/$1/gi){
				$file = &dec_qp($file);
			} elsif ($file =~ /=\?($charset|$charsetM)\?b\?/i){
				$file = decode("MIME-Header", encode($charset,$file));
			} elsif ($file =~ /=\?[^?]+\?Q\?=/){
				$file =~ s/=\?[^?]+\?Q\?//gi;
				$file =~ s/\?=[ \t]*//g;
				$file =~ s/_/ /g;
				$file =~ s/=([a-fA-F0-9][a-fA-F0-9])/pack("H2", $1)/eg;
			}
			if ($file !~ /\.\w+$/ && $tmp =~ /Content-Type: *image\/(gif|jpe*g*|png)/i){
				$file = $tmpname . '_' . sprintf("%02d",$count) . '.' . $1;
				$count++;
			}
		} elsif ($tmp =~ /(file)*name\*\d+\* *=/){
			foreach my $l (split(/\r*\n/,$tmp)){
				$l =~ s/;*$//;
				if ($l =~ s/^\s*(file)*name\*\d+\* *= *($charsetM'+)*//i){$file .= $l;}
			}
			$file =~ s/%([0-9a-fA-F][0-9a-fA-F])/chr(hex($1))/ego;
			$file = &dec_utf($file);
			$count++;
		} elsif ($tmp =~ /Content-Type: *image\/(gif|jpe*g*|png)/i){
			$file = $tmpname . '_' . sprintf("%02d",$count) . '.' . $1;
			$count++;
		}
		next if !$file;
		
		$fid = sprintf("%02s",$c);
		$file =~ /(.*)\.([^.]+)$/;
		my ($fname,$ext) = ($1,$2);
		$file = "(unknown).$ext" if $fname =~ /[\x00-\x1F]/;		# ファイル名に制御コードあり
		if ($ext =~ /[^$zstr]/ || $ext =~ /^com|exe$/i){$ext = 'bin';}		# com/exe, 2バイト文字
		elsif ($ext =~ /^cgi|html?|pl|shtml?|php\d?$/i){$ext = 'txt';}		# 特定テキストファイル
		$outfile = "$fid.$ext";
		
		my ($file1) = &mod_str($file);
		if (grep(/^$file1$/,@fname)){
			for (2 .. 10){
				my $tname = $file;
				$tname =~ s/\.[^.]+$/($_)$&/;
				if (!grep(/^$tname$/,@fname)){
					$file = $tname;
					last;
				}
			}
		}
		$fid = "#". $fid;
		
		$cid{$1} = $outfile if $tmp =~ /Content-ID: *<*([^>]+)/i;		# HTML用画像ID
		push(@fname,$file);
		push(@alist,"$fid\t$outfile\t$file");
		push(@alist0,"$fid\t$outfile\t$file");		# @alist0は転送用
		$c++;
		next if (!$allowdown || !$data);
		
		open(MyFILE,">$dir/$outfile");
			binmode(MyFILE);
			if ($tmp =~ /Encoding: *Base64/i){print MyFILE MIME::Base64::decode($data);}
			else {print MyFILE $data;}
		close(MyFILE);
	}
	
	# HTML 部を保存
	if ($htmltmp1 && $allowhtml){
		while (($cid,$src) = each(%cid)){
			$cid =~ s/[\$\@.]/\\$&/g;
			$htmltmp1 =~ s/cid:$cid/$src/i;
		}
		$htmlfile = "$dir/" . time() . '.html';		# $htmlfile は印刷表示でも使用
		
		# HTMLフォーマットチェック
		$htmltmp1 =~ s/.*/<html>\n$&<\/html>\n/ if $htmltmp1 !~ /<html.*?>/i;
		$htmltmp1 =~ s/<html.*?>/$&\n<head><\/head>\n/ if $htmltmp1 !~ /<head.*?>/i;
		$htmltmp1 =~ s/(<\/head.*?>)(.*)/$1<body>\n$2<\/body>\n/ if $htmltmp1 !~ /<body.*?>/i;
		
		# HTMLのキャラクタセットを判定
		my $Charset;
		if ($htmltmp1 =~ /<meta .*?charset=['"]*([\w\-]+)/i){
			$Charset = lc($1);
			if ($Charset =~ /^(csiso.?2022.?jp|iso.*2022.*jp|jis)/){$Charset = $charsetM;}
			elsif ($Charset =~ /^(cs)*shift.?jis/){$Charset = $charsetS;}
			elsif ($Charset =~ /^euc.?\w+/){$Charset = $charsetE;}
			elsif ($Charset =~ /^utf.?8/){$Charset = $charset;}
		} elsif ($CharS){
			$Charset = $charS;
		} else {
			$Charset = $charset;
		}
		$htmltmp1 =~ s/<head.*?>/$&\n<meta http-equiv='Content-Type' content='text\/html; charset=$Charset'>\n/i
			if $htmltmp1 !~ /<meta .*?Content-Type.*?charset=/i;
		Encode::_utf8_off($htmltmp1);
		Encode::from_to($htmltmp1,$charset,$Charset) if ($Charset && $Charset ne $charset);
		open(MyFILE,">$htmlfile");
			print MyFILE $htmltmp1;
		close(MyFILE);
		$op1 .= "&nbsp;このメッセージは HTML 形式でも閲覧できます。";
		$op1 .= "<a href='$htmlfile' target='_blank'>HTML 形式で見る。$arrowR</a>";
	}
	
	if (!@alist || $op0 eq 'forward'){return();}
	chdir($dir);
	
	# ウイルススキャン
	($scanok,@report) = &vscan('*.*') if (-f $scanner && $allowdown);
	
	# 結果解析、リンク作成
	my $ichk;
	foreach(@alist){
		my ($fid,$outfile,$file) = split(/\t/,$_);
		if (!$allowdown){$attach0 .= "$fid($file), "; next;}
		my $chk;
		my $path = "$dir/$outfile";
		my $iFile = 1 if $outfile =~ /\.(gif|jpe?g?|png)$/i;
		my ($x,$y) = imgsize($outfile) if ($ImageOK && $iFile);
		if (($scanner =~ /\\navw(32|nt)(\.exe)*$/i && !-f "$outfile") || 
			(@report && grep(/[\/\\]$outfile[^.].*(Infection:|Infected|virus)/i,@report)) ||
			($scanner =~ /\\a2cmd(\.exe)*$/i && grep(/\sdetected: *.+/,@report)) ||
			($scanner =~ /\\nod32(\.exe)*$/i && grep(/\x83\x45\x83\x43\x83\x8B\x83\x58\x90\x94:[1-9]/,@report) 
				&& grep(/[\/\\]$outfile /,@report)) ||
			($scanner =~ /\\ecls(\.exe)*$/i && grep(/Infected: +files *- *[1-9]|\x8B\xBA\x88\xD0=".+/,@report)) ||
			($scanner =~ /\\tvscan32(\.exe)*$/i && grep(/\\$outfile +\[.+\]\n/,@report)) ||
			($scanner =~ /\\vscanwin32(\.com)*$/i && grep(/\\$outfile /i,@report)) ||
			($scanner =~ /\\clamd?scan(\.exe)*$/i && grep(/$outfile:.+FOUND/,@report)) ||
			($scanner =~ /\\fsav(\.exe)*$/i && grep(/\x8A\xB4\x90\xF5\s*[1-9]|Infection:\s*[1-9]/i,@report)) ||
			($scanner =~ /\\avgscanx(\.exe)*$/i && grep(/\x20\x82\xAA\x93\xC1\x92\xE8/,@report)) ||
			($scanner =~ /\\fpscan(\.exe)*$/i && grep(/\[Found .+?\] *<.+?>/,@report))
			){$chk = 1;}
		if (!$chk){
			open(MyFILE,">$outfile.tmp");
				flock(MyFILE,2);
				print MyFILE "$outfile\t$file";
			close(MyFILE);
			my ($name) = &enc_str($outfile);
			$attach0 .= "<a href='JavaScript:opn_win(\"$cgidown?$name+$dummy\",480,360)'>";
			if ($ImageOK && $k4xenable && $viewimage && $iFile){
				my ($x2,$y2) = ($x,$y);
				if ($x2 && $x2 > 60){
					$y2 = int($y2*60/$x2);
					$x2 = 60;
				}
				$attach0 .= "<img src='$path' height=$y2 width=$x2 alt='$file' title='$file' border=0>";
				$ichk = 1;
			} else {
				$attach0 .= $clip;
			}
			$attach0 .= "$fid($file)</a>, ";
			# インライン表示が許可された場合
			if ($ImageOK && $inline && $iFile){
				my ($x1,$x2,$y1,$y2,$y3) = ($x,$x,$y,$y,$y);
				my $size = -s $outfile;
				$size = int(($size+1023)/1024);
				1 while $size =~ s/(.*\d)(\d\d\d)/$1,$2/;
				$size .= 'KB';
				1 while $x1 =~ s/(.*\d)(\d\d\d)/$1,$2/;
				1 while $y1 =~ s/(.*\d)(\d\d\d)/$1,$2/;
				my $desc = "$file($size)、${x1}ピクセルx${y1}ピクセル";
				if ($x2 && $x2 > 600){
					$y2 = $y3 = int($y2*600/$x2);
					$x2 = 600;
					1 while $y2 =~ s/(.*\d)(\d\d\d)/$1,$2/;
					$desc .= " を ${x2}x$y2 で縮小表示";
				}
				if ($x){
					$attach2 .= "<p><img src='$path' height=$y3 width=$x2 alt='$file' title='$file' border=0><br>";
					$attach2 .= "<font color='#408040'>$desc</font></p>";
				}
			}
		} else {
			$caution0 .= "$fid($file), ";
			$attach0 .= "$clip$fid(<b>$file</b>), ";
		}
	}
	$attach0 =~ s/(, )+$//;
	$attach2 = "<div align='center' class='doc121'>$attach2</div>" if $attach2;
	chdir('../../cgi');
	
	if ($scanok){
		$scanok = '[ウイルス検査完了]';
		if ($k4xenable && $viewimage && $ichk){$scanok .= '<br>';}
		else {$scanok .= ' ';}
	}
	
	if (!$attach0){return();}
	
	# 警告すべきなら
	if ($allowdown && $caution0){
		$caution0 =~ s/[, ]+$//;
		$caution0 = <<"EOF";
$caution0 はウイルス感染の疑いがあります。<br>
本文を確認した上でこのメッセージを削除することをすすめます。<br>
<font color='black'><li>このメッセージの閲覧、印刷表示と返信は安全です。</font></li>
EOF
		$op1 = '';
	}
	$attach0 = "<tr><td valign='top'>$buttonG 添付:</td><td colspan=2>$scanok$attach0</td></tr>";
	if ($caution0){
		my $title = '危険です!!';
		$attach0 .= <<"EOF";
<table class='doc131'>
<tr valign='top'><td><img src='$idir/stop.gif' width=32 height=32 title='$title' align='left' hspace=4></td>
<td>$fs2$caution0$fe</td></tr>
</table>
EOF
	}
	$attach1 = "<br>（オリジナルメッセージ中の添付ファイルは削除されます）";
}

## ウイルススキャン(古い!!!、NOD以外は機能せず?)
sub vscan {
	my ($files) = @_;
	my $repfile = 'REPORT';
	my ($scanok,@report);
	return() if $OS;
	
	$scanner =~ s/\//\\/g;
	my $dir = $0;
	$dir =~ s/[\\\/]cgi[\\\/].+/\/temp\/$loginid/i;
	$dir =~ s/[\\\/]/\\/g;
	if ($scanner =~ /\\a2cmd(\.exe)*$/i){				# a-squared Command Line Scanner
		$op = "/f=$dir /a /la=$repfile /n";
	} elsif ($scanner =~ /\\fpcmd(\.exe)*$/i){			# F-PROT Antivirus for Windows
		$op = "$files -archive=1 -nosub -old -packed -report=$repfile -server -silent -noboot -nomem";
	} elsif ($scanner =~ /\\fpscan(\.exe)*$/i){			# F-PROT Antivirus for Windows(2015現在も有効)
		$scannerSig =~ s/\//\\/g;
		$op = "/signatures=\"$scannerSig\" --archive=5 --verbose=1 --output=$repfile --report $files";
	} elsif ($scanner =~ /\\avgscan(\.exe)*$/i){		# AVG Antivirus Free Edition
		$op = "/ARC /RT /EXT=* /NOBOOT /NOMEM /NOHIMEM /REPORT $repfile .\\";
	} elsif ($scanner =~ /\\avgscanx(\.exe)*$/i){		# AVG Antivirus V8 Free Edition(日本語版)
		$op = "/ARC /EXT=* /IGNLOCKED /NOBREAK /REPORT=$repfile /SCAN=.\\";
	} elsif ($scanner =~ /\\scan(\.exe)*$/i){			# McAfee VirusScan Enterprise
		$op = "$files /MIME /UNZIP /NOBOOT /NOMEM /REPORT $repfile";
	} elsif ($scanner =~ /\\navw(32|nt)(\.exe)*$/i){	# Norton Antivirus
		$op = "/B- /HEUR:0 /M- /S- /NORESULTS $files";
	} elsif ($scanner =~ /\\nod32(\.exe)*$/i){			# NOD32ver2(日本語版)
		$repfile = "$dir\\$repfile";
		$op = "/selfcheck- /expire- /sound- /quit+ /pattern+ /heur- /scanboot- /scanmbr- /arch+ /list- /pack+ ";
		$op .= "/all /logrewrite /log=$repfile $dir";
	} elsif ($scanner =~ /\\ecls(\.exe)*$/i){			# NOD32/Smart Security ver3/ver4(日本語版)
		my $basedir = $scanner;
		$basedir =~ s/[\\\/]ecls(\.exe)*$//i;
		$repfile = "$dir\\$repfile.__K4";
		$ECLSver = `"$scanner" --version`;
		if ($ECLSver =~ /\\ecls(\.exe)* +4\./i){		# NOD32ver4/Smart Security(日本語版)
			$ECLSver = '4';
			$op = "/base-dir=\"$basedir\" /log-file=$repfile /ext-exclude=__K4 /clean-mode=none /no-ads $dir";
		} else {										# NOD32ver3/Smart Security(日本語版)
			$ECLSver = '3';
			$op = "/base-dir=\"$basedir\" /log-file=$repfile /ext-exclude=__K4 /action=none $dir";
		}
	} elsif ($scanner =~ /\\vscanwin32(\.com)$/i){		# Trend Micro Client/Server Security(Client)
		$op = "/S /NM /NB /NC /LD=$repfile /Q *.*>temp";
	} elsif ($scanner =~ /\\tvscan32(\.exe)*$/i){		# Trand Micro VirusBuster2008
		$op = "/NM /NB /NC /NHEADER /LD=$repfile $dir";
	} elsif ($scanner =~ /\\clamscan(\.exe)*$/i){		# Clamwin(2015現在でも有効だが動作が遅い)
		return() if !-d "$clamdb";
		$clamdb =~ s/\//\\/g;
		$op = "--database=\"$clamdb\" --tempdir=\"$dir\" --log=$repfile --quiet --infected  --no-summary";
	} elsif ($scanner =~ /\\clamdscan(\.exe)*$/i){		# ClamAV
		$op = "--log=$repfile --quiet --infected  --no-summary";
	} elsif ($scanner =~ /\\fsav(\.exe)*$/i){			# F-Secure AntiVirus Server/Client Security
		$op = "/ARCHIVE /LIST /NOBOOT /REPORT=$repfile /SILENT $files";
	} elsif ($scanner =~ /\\bdc(\.exe)*$/i){			# SOFTWIN BitDefender Free Edition
		$op = "$dir /arc /log=$repfile /noc /nowarn";
	} else {return();}
	unlink($repfile);
	if ($scanner =~ /\\f-prot(\.exe)*$/i){system("$scanner $op");}
	else {system("\"$scanner\" $op>.temp");}
	
	if ($scanner =~ /\\navw(32|nt)(\.exe)*$/i){return 1;}
	if (open(MyFILE,$repfile)){
			@report = <MyFILE>;
		close(MyFILE);
		$scanok = 1;
	}
	unlink($repfile);
	($scanok,@report);
}

## 全角→半角変換
sub zenhan {
	foreach(@_){$$_ =~ tr/０-９Ａ-Ｚａ-ｚ　！”“＃＄％＆’（）＊＋，－．／：；＜＝＞？＠［￥］＾＿‘｛｜｝～/0-9A-Za-z \!\"\"#\$\%\&'\(\)\*\+,\-\.\/:;<=>\?\@\[\\\]\^_`{\|}~/;}
}

1;
